// Bluetooth Control interface
// Written by Boomer48: April 2019

// Input port for Direction switch
// Can be any of the Arduino defined digital pins
#define Forward 9
#define Reverse 10
#define PWM 3

byte Duty_Cycle;
char BT_Command;

// Make routines globally visible
void Bluetooth_setup();
void Bluetooth_loop();

// Code goes here
void Bluetooth_setup() {
  BT_Command = ' ';
  Serial.begin(9600);
}

void Bluetooth_loop() {
  if (Serial.available() > 0) {
    // read the incoming byte
    BT_Command = Serial.read();

    if (BT_Command == 'T') {
      // Throttle
      if (Duty_Cycle < 255)
        Duty_Cycle++;
      analogWrite(PWM, Duty_Cycle);
    }

    if (BT_Command == 'B') {
      // Brake
      if (Duty_Cycle > 0)
        Duty_Cycle--;
      analogWrite(PWM, Duty_Cycle);
    }

    if (BT_Command == 'F') {
      // Forward
      Duty_Cycle = 0;
      analogWrite(PWM, Duty_Cycle);
      digitalWrite(Forward, HIGH);
      digitalWrite(Reverse, LOW);
    }

    if (BT_Command == 'R') {
      // Reverse
      Duty_Cycle = 0;
      analogWrite(PWM, Duty_Cycle);
      digitalWrite(Forward, LOW);
      digitalWrite(Reverse, HIGH);
    }
  }
}
