// Manual Control interface
// Written by Boomer48: April 2019

// Input port for Direction switch
// Can be any of the Arduino defined digital pins
#define Direction 2
#define Throttle 7
#define Brake 8
#define Forward 9
#define Reverse 10
#define PWM 3

byte temp;
byte Duty_Cycle;

// Make routines globally visible
void Manual_setup();
void Manual_loop();

// Code goes here
void Manual_setup() {
  pinMode(Direction, INPUT_PULLUP); //turn on pullup
  pinMode(Throttle, INPUT_PULLUP); //turn on pullup
  pinMode(Brake, INPUT_PULLUP); //turn on pullup

  // Calculate register settings for interrupt on change
#if ((Direction <= 13) & (Direction >= 8))
  temp = Direction - 8;
  bitSet(PCMSK0, temp);
  PCICR = B00000001; // enable PCIE0 group
#else
  bitSet(PCMSK2, Direction);
  PCICR = B00000100; // enable PCIE2 group
#endif
  PCIFR = B00000000; // clear all pin change interrupt flags
}

void Manual_loop() {
  delay(50);  // about 14 seconds to go from 0-100 or 100-0

  if (digitalRead(Throttle) == LOW)
    if (Duty_Cycle < 255)
      Duty_Cycle++;

  if (digitalRead(Brake) == LOW)
    if (Duty_Cycle > 0)
      Duty_Cycle--;

  if (digitalRead(Direction) == HIGH) {
    digitalWrite(Forward, HIGH);
    digitalWrite(Reverse, LOW);
  }
  else {
    digitalWrite(Forward, LOW);
    digitalWrite(Reverse, HIGH);
  }

  analogWrite(PWM, Duty_Cycle);
}

// Interrupt-on-change handler
#if ((Direction <= 13) & (Direction >= 8))
ISR (PCINT0_vect) {
#else
ISR (PCINT2_vect) {
#endif

  analogWrite(PWM, 0);
  Duty_Cycle = 0;
}
